﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace LS_ReaderWriterLockSlim
{
    class Program
    {
        const int MaxProcessi = 50;        // Metà lettori, metà scrittori
        const int RitardoLettura = 5;      // ms
        const int RitardoScrittura = 10;    // ms
        static ReaderWriterLockSlim rwlock = new ReaderWriterLockSlim();
        static int buffer = 100;

        static void Leggi(int idLettore)
        {
            int dato;
            rwlock.EnterReadLock();

            if (RitardoLettura > 0)
                Thread.Sleep(RitardoLettura);
            dato = buffer;
            Console.WriteLine("Il lettore n. {0} ha letto il buffer. Valore rilevato: {1}", idLettore, dato);

            rwlock.ExitReadLock();
        }
        static void Scrivi(int idScrittore)
        {
            int dato;
            rwlock.EnterWriteLock();

            if (RitardoScrittura > 0)
                Thread.Sleep(RitardoScrittura);
            dato = buffer;
            dato++;
            buffer = dato;
            Console.WriteLine("Lo scrittore n. {0} ha modificato il buffer. Nuovo valore: {1}", idScrittore, dato);

            rwlock.ExitWriteLock();
        }
        static void Main(string[] args)
        {
            List<Task> lista = new List<Task>();
            for (int i = 1; i <= MaxProcessi / 2; i++)
            {
                int id = i;
                // Avvia un nuovo task lettore
                lista.Add(Task.Factory.StartNew(() => Leggi(id), TaskCreationOptions.LongRunning));
                // Avvia un nuovo task scrittore
                if (((id-1) % 10) == 0)
                    lista.Add(Task.Factory.StartNew(() => Scrivi(id), TaskCreationOptions.LongRunning));
            }

            // Attende la fine di tutti i lettori/scrittori 
            Task.WaitAll(lista.ToArray());
        }
    }
}
